#!/bin/sh
# filename: /var/bin/firewall.resolve.sh
export PATH=/sbin:/usr/sbin:/bin:/usr/bin
IPTABLES=`which iptables`
DYNDNS="/var/etc/firewall.dyndns"
RESTARTEMU="0"
GBOXFILE="/tmp/gbox.state"
ETAT="0"

# Here you can modify the line just after to give the path and name of your Emu
EMU="/var/etc/plimgr/scripts/gbox"

# first call dos2unix to be sure the file is in unix format
dos2unix $DYNDNS

ACTIF=`ls /tmp | grep -c actif`
if [ $ACTIF = 0 ]; then
	exit
fi

for HOST in $(cat $DYNDNS)
do

HOSTFILE="/tmp/$HOST"
IP=""
TRAVAIL=""
OLDIP=""
# lookup host name from dns tables
TRAVAIL=`nslookup $HOST | grep Address`
IP=`echo $TRAVAIL | awk '{print $4}'`

if [ -r $HOSTFILE ]; then
    OLDIP=`cat $HOSTFILE`
    if [ $OLDIP != $IP ]; then
        # save off new ip.
        echo $IP>$HOSTFILE
        # echo "Updating $HOST in iptables."
        # echo "Removing old rule ($OLDIP)"
        $IPTABLES -D INPUT -s $OLDIP/32 -j ACCEPT
        # echo "Inserting new rule ($IP)"
        $IPTABLES -A INPUT -s $IP/32 -j ACCEPT

# If you want automatic restart of your Emu after a change of IP adresse
# you can uncomment the line after by removing the #
#        RESTARTEMU="1"

# If you use Gbox Emu than uncomment the line after by removing the #
#	echo 1 > $GBOXFILE
    fi

else

    # save off new ip.
    echo $IP>$HOSTFILE
    # echo "Inserting new rule ($IP)"
    $IPTABLES -A INPUT -s $IP/32 -j ACCEPT

fi

done

if [ $RESTARTEMU = 1 ]; then
	$EMU stop
	$EMU start
fi

ETAT=`ls /tmp | grep -c gbox.state`
if [ $ETAT = 1 ]; then
        /var/bin/firewall.gbox.sh
fi
